#pragma once

#include "Participants/ParticipantUDP.h"

#if defined(HAS_WIFI)
#include <WiFiUdp.h>
#endif

namespace RoboidControl {
namespace Arduino {

class ParticipantUDP : public RoboidControl::ParticipantUDP {
 public:
  void Setup();
  void Receive();
  bool Send(Participant* remoteParticipant, int bufferSize);
  bool Publish(IMessage* msg);

 protected:
#if defined(HAS_WIFI)
  char* broadcastIpAddress = nullptr;

  WiFiUDP udp;
#endif

  void GetBroadcastAddress();
};

}  // namespace Arduino
}  // namespace RoboidControl
